<?php
/**
*
* @package who_is_where  v.0.0.1
* @version $Id: who_is_where.php 2356 2011-09-04 08:15:36Z 4seven $
* @copyright (c) 2011 / 4seven
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx); 

$user->session_begin();
$auth->acl($user->data);
$user->setup('viewforum');

if($auth->acl_gets('u_viewprofile', 'a_user', 'a_useradd', 'a_userdel')){

header('Content-type: text/html; charset=utf-8');

echo '<fieldset>
	  <dl>
	  <dt>Who</dt>	
	  <dd>Where</dd>
	  </dl>
	  <dl>';
	  
	function user_get_name($u_id)
	{
	   global $db;
	   $sql = 'SELECT username, user_colour
	         FROM ' . USERS_TABLE . '
	         WHERE user_id = ' . $db->sql_escape($u_id);
	   $result = $result = $db->sql_query_limit($sql, 1);
	   $row = $db->sql_fetchrow($result);
	   $db->sql_freeresult($result);
   
	   if($row)
	   {
	      return ': ' . get_username_string('no_profile', $u_id, $row['username'], $row['user_colour']);
	   }
	   else
	   {
	      return '';
	   }
	}

	// Forum info
	$sql = 'SELECT forum_id, forum_name, parent_id, forum_type, left_id, right_id
		FROM ' . FORUMS_TABLE . '
		ORDER BY left_id ASC';
	$result = $db->sql_query($sql, 600);
	
	$forum_data = array();
	while ($row = $db->sql_fetchrow($result))
	{
		$forum_data[$row['forum_id']] = $row;
	}
	$db->sql_freeresult($result);
	
	$sql_hidden = (!$auth->acl_get('u_viewonline')) ? 'AND session_viewonline != 0 AND user_allow_viewonline !=0' : '';

	$sql = 'SELECT DISTINCT (session_user_id), session_forum_id, session_page, session_viewonline, username, user_colour, user_allow_viewonline
		FROM ' . SESSIONS_TABLE . ' s, ' . USERS_TABLE . ' u
		WHERE session_user_id != ' . ANONYMOUS . "
		$sql_hidden
	    AND group_id != 6
		AND session_user_id = user_id
		AND session_time >= " . (time() - ($config['load_online_time'] * 60)) . '
		GROUP BY session_user_id';
		
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
	
	$sizeof_row[] = array();

	preg_match('#^([a-z0-9/_-]+)#i', $row['session_page'], $on_page);
	if (!sizeof($on_page))
	{
		$on_page[1] = '';
	}

	$on_apps    = explode("?",$row['session_page']); 
	$on_apps    = (!empty($on_apps[1])) ? $on_apps[1] : '';
	
	preg_match('#(&u=)([0-9]+)#', $on_apps, $on_ap);
	$on_apps_u  = (!empty($on_ap[2])) ? user_get_name($on_ap[2]) : '';	

	switch ($on_page[1])
	{
		case 'index':
			$location = $user->lang['INDEX'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;

		case 'adm/index':
			$location = $user->lang['ACP'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;

		case 'posting':
		case 'viewforum':
		case 'viewtopic':
			$forum_id = $row['session_forum_id'];

			if ($forum_id && $auth->acl_get('f_list', $forum_id))
			{
				$location = '';
				$location_url = append_sid("{$phpbb_root_path}viewforum.$phpEx", 'f=' . $forum_id);

				if ($forum_data[$forum_id]['forum_type'] == FORUM_LINK)
				{
					$location = sprintf($user->lang['READING_LINK'], $forum_data[$forum_id]['forum_name']);
					break;
				}

				switch ($on_page[1])
				{
					case 'posting':
						preg_match('#mode=([a-z]+)#', $row['session_page'], $on_page);
						$posting_mode = (!empty($on_page[1])) ? $on_page[1] : '';

						switch ($posting_mode)
						{
							case 'reply':
							case 'quote':
								$location = sprintf($user->lang['REPLYING_MESSAGE'], $forum_data[$forum_id]['forum_name']);
							break;

							default:
								$location = sprintf($user->lang['POSTING_MESSAGE'], $forum_data[$forum_id]['forum_name']);
							break;
						}
					break;

					case 'viewtopic':
						$location = sprintf($user->lang['READING_TOPIC'], $forum_data[$forum_id]['forum_name']);
					break;

					case 'viewforum':
						$location = sprintf($user->lang['READING_FORUM'], $forum_data[$forum_id]['forum_name']);
					break;
				}
			}
			else
			{
				$location = $user->lang['INDEX'];
				$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
			}
		break;

		case 'search':
			$location = $user->lang['SEARCHING_FORUMS'];
			$location_url = append_sid("{$phpbb_root_path}search.$phpEx");
		break;

		case 'faq':
			$location = $user->lang['VIEWING_FAQ'];
			$location_url = append_sid("{$phpbb_root_path}faq.$phpEx");
		break;

		case 'viewonline':
			$location = $user->lang['VIEWING_ONLINE'];
			$location_url = append_sid("{$phpbb_root_path}viewonline.$phpEx");
		break;

		case 'memberlist':
			$location = (strpos($row['session_page'], 'mode=viewprofile') !== false) ? $user->lang['VIEWING_MEMBER_PROFILE'] : $user->lang['VIEWING_MEMBERS'];
			$location_url = append_sid("{$phpbb_root_path}memberlist.$phpEx", $on_apps);
		break;

		case 'mcp':
			$location = $user->lang['VIEWING_MCP'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;

		case 'ucp':
			$location = $user->lang['VIEWING_UCP'];

			// Grab some common modules
			$url_params = array(
				'mode=register'		=> 'VIEWING_REGISTER',
				'i=pm&mode=compose'	=> 'POSTING_PRIVATE_MESSAGE',
				'i=pm&'				=> 'VIEWING_PRIVATE_MESSAGES',
				'i=profile&'		=> 'CHANGING_PROFILE',
				'i=prefs&'			=> 'CHANGING_PREFERENCES',
			);

			foreach ($url_params as $param => $lang)
			{
				if (strpos($row['session_page'], $param) !== false)
				{
					$location = $user->lang[$lang];
					break;
				}
			}

			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;

		case 'download/file':
			$location = $user->lang['DOWNLOADING_FILE'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;

		case 'report':
			$location = $user->lang['REPORTING_POST'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;

		default:
			$location = $user->lang['INDEX'];
			$location_url = append_sid("{$phpbb_root_path}index.$phpEx");
		break;
	}
	
	$get_username = (($row['session_viewonline'] == 1) || ($row['user_allow_viewonline'] == 1)) ? '<dt>' . get_username_string('full', $row['session_user_id'], $row['username'], $row['user_colour']) . '</dt>' : '<dt><span style="font-style:italic;">' . get_username_string('full', $row['session_user_id'], $row['username'], $row['user_colour']) . '</span></dt>';

	echo $get_username;
	
	echo '<dd><a href="' . $location_url.'" title="'.$location.'">'.$location . '</a>' . $on_apps_u . '</dd>';

	}
	$db->sql_freeresult($result);

	if (!isset($sizeof_row)){
	echo '<dt>Nobody</dt>';	
	echo '<dd>Nowhere</dd>';}

	echo '</dl>
	      </fieldset>';
		  
		  }

?>